/*
  Copyright		(c)2011 Paolo Lavacchini (All rights reserved)
  Date:         8/2/2011
  Projet name: 	LAB 
  Site          www.lsoft.it
  Contact:      p.lavacchini@tin.it
  Subject:      open source for Arduino L_soft Arduino Basic
  Status:		Preliminary
  Version:		0.1 (10/03/2011)

  Modified:		none
  Conributors:	none

  This program is free software: you can redistribute it and/or modify 
  it under the terms of the GNU General Public License as published by 
  the Free Software Foundation, either version 3 of the License, or 
  (at your option) any later version. 

  This program is distributed in the hope that it will be useful, 
  but WITHOUT ANY WARRANTY; without even the implied warranty of 
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
  GNU General Public License for more details. 

  You should have received a copy of the GNU General Public License 
  along with this program. If not, see <http://www.gnu.org/licenses/>. 

*/





extern char		*Get_number		(char*,long*);
extern char		*Fast_Get_Next	(int);
extern char		*Get_value		(char*,long*);
extern char		*Get_variable	(char*,long*);
extern char		*Get_Register	(char*,long *);
extern char		*Get_expression	(char*,long*);

extern void		Save			(void);
extern void		Load			(void);
extern void		Delay_1mS		(void);
extern void		A_putc			(char);
extern char		*Skip_Blank		(char*);
extern int		Get_Line_Pnt	(int);
extern int		List			(char*);
extern int		Get_Next		(int);
extern char		*Skip_Line_Num	(char*);
extern int		Check_Term		(char*);
extern int		Insert_Line		(char*);
extern void		New				(void);
extern int		Get_Edit_Line	(char,char*);
extern int		Help			(void);
extern int		Test_Variable	(char*);
extern int		Scan_Line		(char*,int);
extern void		Line_To_Upper	(char*);
extern int		fastgnext		(int);
extern int		Setup_FLUT		(void);
extern int		Print_Instr		(char*);
extern int		Run_Instr		(char*,int);
extern int		Set_variable	(char*,int);
extern int		Load_variable	(char*);
extern int		Test_if_num		(char*);
extern int		A_printf		(char *fmt,...);
extern int		A_getch			(void);
extern int		A_sense_char	(void);
extern int		Field_input		(char*);
extern void		A_Board_Init	(void);
extern int		Renum_program	(char *l);
extern int		Get_Ordinal		(int);
extern void		Set_Reg_AVR		(int,unsigned char);
extern char 	Get_Auto_Run (void);
extern unsigned char	Get_Reg_AVR	(int);
extern unsigned char 	Read_E2PROM (unsigned int);
extern void 			Write_E2PROM(unsigned int,unsigned char);
extern void 			Save 		(void);
extern void 			Load 		(void);


#ifdef DEBUG_ON
extern clock_t		A_clock		(void);
#endif

#ifdef ON_BOARD
extern unsigned long A_clock	(void);
#endif



#ifdef ON_BOARD

extern void				Timer_5_Init		(void);
extern int				Serial_Init			(unsigned long,char,char,char);
extern unsigned char	Serial_Rx_Char		(void);
extern void				Serial_Tx_Char		(unsigned char);
extern int				Serial_Tx_String	(char *fmt,...);
extern unsigned char	Serial_Sense_Rx		(void);

#endif




